



C...These are som conversion routines to forward calls to old
C...JETSET7/PYTHIA5 routines in case we are not running in the PYTHIA6
C...framework.

      INTEGER FUNCTION PYK(I,J)
      PYK=KLU(I,J)
      RETURN
      END

      DOUBLE PRECISION FUNCTION PYR(IDUM)

      PYR=DBLE(RLU(IDUM))

      RETURN
      END

      DOUBLE PRECISION FUNCTION PYMASS(KQ)

      PYMASS=DBLE(ULMASS(KQ))

      RETURN
      END

      DOUBLE PRECISION FUNCTION PYANGL(DX,DY)

      DOUBLE PRECISION DX,DY

      PYANGL=DBLE(ULANGL(REAL(DX),REAL(DY)))

      RETURN
      END

      SUBROUTINE PYHEPC(I)

      CALL LUHEPC(I)

      RETURN
      END

      SUBROUTINE PYEXEC

      CALL LUEXEC

      RETURN
      END

      SUBROUTINE PYROBO(I,N,THE,PHI,DBX,DBY,DBZ)
      DOUBLE PRECISION THE,PHI,DBX,DBY,DBZ

      CALL LUDBRB(I,N,REAL(THE),REAL(PHI),DBX,DBY,DBZ)

      RETURN
      END

      INTEGER FUNCTION PYCOMP(I)

      PYCOMP=LUCOMP(I)

      RETURN
      END

      INTEGER FUNCTION PYCHGE(I)

      PYCHGE=LUCHGE(I)

      RETURN
      END

      SUBROUTINE PYLIST(I)

      CALL LULIST(I)

      RETURN
      END

      SUBROUTINE PYPTDI(I,DX,DY)
      DOUBLE PRECISION DX,DY
      REAL PX,PY

      CALL LUPTDI(I,PX,PY)
      DX=DBLE(PX)
      DY=DBLE(PY)

      RETURN
      END

      SUBROUTINE PYZDIS(I,J,X,DZ)
      DOUBLE PRECISION X,DZ
      REAL PZ

      CALL LUZDIS(I,J,REAL(X),PZ)
      DZ=DBLE(PZ)

      RETURN
      END

      SUBROUTINE PYPDFU(K,X,T,DXF)
      DOUBLE PRECISION X,T,DXF
      DIMENSION DXF(-25:25)
      REAL PXF(-25:25)

      CALL PYSTFU(K,SNGL(X),SNGL(T),PXF)
      DO 100 I=-25,25
         DXF(i)=DBLE(PXF(I))
 100  CONTINUE

      RETURN
      END

      SUBROUTINE PYKFDI(I1,I2,I3,I4)

      CALL LUKFDI(I1,I2,I3,I4)

      RETURN
      END

      DOUBLE PRECISION FUNCTION PYALEM(X)
      DOUBLE PRECISION X

      PYALEM=DBLE(ULALEM(SNGL(X)))

      RETURN
      END

      SUBROUTINE PYEEVT(I,X)
      DOUBLE PRECISION X

      CALL LUEEVT(I,SNGL(X))

      RETURN
      END

      SUBROUTINE PYERRM(MERR,CHMESS)
      CHARACTER CHMESS*(*)

      CALL LUERRM(MERR,CHMESS)

      RETURN
      END

      SUBROUTINE PY2ENT(IP,KF1,KF2,PECM)
      DOUBLE PRECISION PECM

      CALL LU2ENT(IP,KF1,KF2,SNGL(PECM))

      RETURN
      END

      SUBROUTINE PYX3JT(NJET,CUT,KFL,ECM,X1,X2)
      DOUBLE PRECISION CUT,ECM,X1,X2

      CALL LUX3JT(NJET,SNGL(CUT),KFL,SNGL(ECM),RX1,RX2)
      X1=DBLE(RX1)
      X2=DBLE(RX2)

      RETURN
      END

      SUBROUTINE PY3ENT(IP,KF1,KF2,KF3,PECM,X1,X3)
      DOUBLE PRECISION PECM,X1,X3

      CALL LU3ENT(IP,KF1,KF2,KF3,SNGL(PECM),SNGL(X1),SNGL(X3))

      RETURN
      END

      SUBROUTINE PYX4JT(NJET,CUT,KFL,ECM,KFLN,X1,X2,X4,X12,X14)
      DOUBLE PRECISION CUT,ECM,X1,X2,X4,X12,X14

      CALL LUX4JT(NJET,SNGL(CUT),KFL,SNGL(ECM),
     $     KFLN,RX1,RX2,RX4,RX12,RX14)
      X1=DBLE(RX1)
      X2=DBLE(RX2)
      X4=DBLE(RX4)
      X12=DBLE(RX12)
      X14=DBLE(RX14)

      RETURN
      END

      SUBROUTINE PY4ENT(IP,KF1,KF2,KF3,KF4,PECM,X1,X2,X4,X12,X14)
      DOUBLE PRECISION PECM,X1,X2,X4,X12,X14

      CALL LU4ENT(IP,KF1,KF2,KF3,KF4,SNGL(PECM),
     $     SNGL(X1),SNGL(X2),SNGL(X4),SNGL(X12),SNGL(X14))

      RETURN
      END

      SUBROUTINE PYXDIF(NC,NJET,KFL,ECM,CHI,THE,PHI)
      DOUBLE PRECISION ECM,CHI,THE,PHI

      CALL LUXDIF(NC,NJET,KFL,SNGL(ECM),RCHI,RTHE,RPHI)
      CHI=DBLE(RCHI)
      THE=DBLE(RTHE)
      PHI=DBLE(RPHI)

      RETURN
      END

      SUBROUTINE ARGPYV(IVER)

      IVER=5

      RETURN
      END

